function [LV in_data] = fem_2_staticUniform(in_data,L_,LVEC)

% -------------------------------------------------------------------------



dof_   = size(in_data.ND,1)*3;
Nbeams = size(in_data.EL,1);

LV     = sparse(dof_,1,0);
in_data.qn = sparse(1,Nbeams);

for b=1:Nbeams

    node1 = find(in_data.ND(:,1)==in_data.EL(b,3));
    node2 = find(in_data.ND(:,1)==in_data.EL(b,4));

    x1 = in_data.ND(node1,2); y1 = in_data.ND(node1,3);
    x2 = in_data.ND(node2,2); y2 = in_data.ND(node2,3);
    L =  sqrt((x2-x1)^2+(y2-y1)^2);

    g = [ 3*node1-2 ; 3*node1-1 ; 3*node1 ; 3*node2-2 ; 3*node2-1 ; 3*node2 ];
    
    c = (x2-x1) / L;
    s = (y2-y1) / L;

    T = [ c s 0   0 0 0 ;
         -s c 0   0 0 0 ;
          0 0 1   0 0 0 ;
          0 0 0   c s 0 ;
          0 0 0  -s c 0 ;
          0 0 0   0 0 1 ];
    
    Qr   = [-s c;c s]*[in_data.qx(b) in_data.qy(b)]';
    Qadd = [Qr(2)*c*L/2 Qr(2)*s*L/2 0 Qr(2)*c*L/2 Qr(2)*s*L/2 0]';
    in_data.qn(b) = Qr(1);
    P_local = [ 0 ; Qr(1)*L/2 ; Qr(1)*L^2/12 ; 0 ; ...
              Qr(1)*L/2 ; -Qr(1)*L^2/12 ];
    
    LV(g) = LV(g) + Qadd + T' * P_local;
end
LV = LV';
