function [resp,LVEC] = fem_1_static(obj,in_data,L,dofN,dof_, ...
                       type_analysis,break_K,varargin)

% -------------------------------------------------------------------------




dPath = which ('tmp_dir.txt');
cd (dPath(1:end-11));
[LVEC] = fem_2_staticLoads(dofN, dof_, in_data, L);

[dofN,EL_TYPE] = fem_0_elemType (in_data);
if EL_TYPE ==0 | EL_TYPE==1 | EL_TYPE==2
    if  isfield(in_data,'qx')
        [LV in_data] = fem_2_staticUniform(in_data,L,LVEC);
        LVEC = LVEC+LV; clear LV;
    end
end

sp_=sprintf('\n');
disp([sp_  '  ...   Load vector - completed.  Time (sec): ' num2str(toc)]);
LK=dof_;

switch length(break_K)
    case 4
        L_1 = L(L>=break_K(1) & L<=break_K(2));
        L_2 = L(L>=break_K(3) & L<=break_K(4))-break_K(3)+1;
        obj.Ksys.Kgl_11 = obj.Ksys.Kgl_11(L_1, L_1);
        obj.Ksys.Kgl_12 = obj.Ksys.Kgl_12(L_1, L_2);
        obj.Ksys.Kgl_21 = obj.Ksys.Kgl_21(L_2, L_1);
        obj.Ksys.Kgl_22 = obj.Ksys.Kgl_22(L_2, L_2);

        CHLc_11 = chol(obj.Ksys.Kgl_11);
        disp_2 = (obj.Ksys.Kgl_22 - ...
            obj.Ksys.Kgl_21*(CHLc_11\(CHLc_11'\obj.Ksys.Kgl_12)))\...
            (LVEC(end-length(L_2)+1:end)' - ...
            obj.Ksys.Kgl_21*(CHLc_11\(CHLc_11'\LVEC(1:end-length(L_2))')));
        disp_1 = CHLc_11\(CHLc_11'\ (LVEC(1:end-length(L_2))' - ...
            obj.Ksys.Kgl_12*disp_2  ));
        displacements = [disp_1 ; disp_2];
        clear CHLc_11 disp_1 disp_2;
    case 2
        resp.static.D=zeros(1,LK);
        if  isfield(in_data,'slaves')
            if  isfield(in_data,'DBC')==0
                [displacements] = fem_2_staticMslave(obj.Ksys.Kgl,L, ...
                    LVEC,in_data.slaves,in_data.master,1);
                nfi=[find(displacements==Inf) ; find(displacements==-Inf)];
                displacements(nfi)=0;
                resp.static.D=zeros(1,LK);
                resp.static.D(L) = displacements(L);
            else
                [displacements] = fem_2_DBC(obj.Ksys.Kgl,L,LVEC,in_data);
                nfi=[find(displacements==Inf) ; find(displacements==-Inf)];
                displacements(nfi)=0;
                resp.static.D = displacements' ;
            end
        else
            if  isfield(in_data,'DBC')
                [displacements] = fem_2_DBC(obj.Ksys.Kgl,L,LVEC,in_data);
                nfi=[find(displacements==Inf) ; find(displacements==-Inf)];
                displacements(nfi)=0;
                resp.static.D = displacements' ;
            else
                displacements = (obj.Ksys.Kgl(L,L))\LVEC(L)';
                nfi=[find(displacements==Inf) ; find(displacements==-Inf)];
                displacements(nfi)=0;
                resp.static.D(L) = displacements ;
            end
        end
end


disp([sp_  '  ...   Displacements - solved.      Time (sec): ' num2str(toc)]);
SF_ = zeros(size(in_data.ND,1), dofN+1);
SF_(1:size(in_data.ND,1),1)=[1:size(in_data.ND,1)]';

for i=1:size(in_data.ND,1)
    SF_(i,dofN-(dofN-1)+1:dofN+1) = [resp.static.D(i*dofN-(dofN-1):i*dofN)];
end;
cd (dPath(1:end-11));
save FEM_STATIC_DISPL.txt SF_ -ascii;
disp([sp_ '--- Static Displacements --> "FEM_STATIC_DISPL.txt": [elem# d1 ... dn]']);
clear displacements SF_

resp.static.stress = fem_2_plotStatic(in_data,obj,resp,type_analysis,varargin{1});

